diff -urNad nedit-5.6~cvs20081118~/source/window.c nedit-5.6~cvs20081118/source/window.c
--- nedit-5.6~cvs20081118~/source/window.c	2014-02-02 14:59:37.980168305 +1100
+++ nedit-5.6~cvs20081118/source/window.c	2014-02-02 14:59:42.844168269 +1100
@@ -193,6 +193,176 @@
 
 static WindowInfo *inFocusDocument = NULL;  	/* where we are now */
 static WindowInfo *lastFocusDocument = NULL;	    	/* where we came from */
+
+#ifdef SWITCH_DOCUMENTS_PATCH
+
+typedef struct SwitchDocumentsListNode
+{
+    int windowIDdebug;
+    WindowInfo * focusDocument;
+    struct SwitchDocumentsListNode* next;
+    struct SwitchDocumentsListNode* previous;
+} SwitchDocumentsList;
+
+static SwitchDocumentsList* firstNodeInSwitchDocumentsList;
+static SwitchDocumentsList* activeNodeInSwitchDocumentsList;
+int switchDocumentsListTraverseDisableMarkActiveDocument;
+struct timeval switchDocumentsClockLastSave;
+int switchingDocumentsAtPresent;
+
+struct timeval getTimeNow()
+{
+    struct timeval timenow;
+    gettimeofday(&timenow, NULL);
+    /*
+    OLD:
+    time_t timenow;
+    time(&timenow);
+    */
+    return timenow;
+}
+
+void printWindowList()
+{
+    printf("*****printWindowList:******\n");
+    printf("firstNodeInSwitchDocumentsList = %d\n", firstNodeInSwitchDocumentsList->windowIDdebug);
+    printf("activeNodeInSwitchDocumentsList = %d\n", activeNodeInSwitchDocumentsList->windowIDdebug);
+    SwitchDocumentsList* currentNode = firstNodeInSwitchDocumentsList;
+    WindowInfo *win;   
+     
+    while(currentNode->next != NULL)
+    {
+    	printf("\tcurrentNode = %d, currentNode pointer = %d\n", currentNode->windowIDdebug, currentNode->focusDocument);
+    	currentNode = currentNode->next;
+    }
+    /*
+    for(win = WindowList; win; win=win->next)
+    {
+    	printf("\twindowList pointer = %d\n", win);
+    } 
+    */
+}
+
+void initialiseSwitchDocumentsList()
+{
+    //printf("initialiseSwitchDocumentsList\n");
+    switchDocumentsClockLastSave = getTimeNow();
+    firstNodeInSwitchDocumentsList = malloc(sizeof(SwitchDocumentsList));
+    firstNodeInSwitchDocumentsList->windowIDdebug = 0;
+    firstNodeInSwitchDocumentsList->focusDocument = NULL;
+    firstNodeInSwitchDocumentsList->next = NULL;
+    firstNodeInSwitchDocumentsList->previous = NULL;
+    activeNodeInSwitchDocumentsList = firstNodeInSwitchDocumentsList;
+    switchDocumentsListTraverseDisableMarkActiveDocument = 0;
+    switchingDocumentsAtPresent = 0;
+    //printWindowList();	//debug
+    //printf("finish initialiseSwitchDocumentsList\n");
+    
+}
+
+SwitchDocumentsList* switchDocumentsGetLastNodeInList()
+{
+    SwitchDocumentsList* currentNode = firstNodeInSwitchDocumentsList;
+    SwitchDocumentsList* lastNodeInList = currentNode;
+    while(currentNode->next != NULL)
+    {
+    	lastNodeInList = currentNode;
+    	currentNode = currentNode->next;
+    }
+    return lastNodeInList;
+}
+		    
+SwitchDocumentsList* switchDocumentsListRemoveNode(SwitchDocumentsList* nodeToRemove)
+{
+    //printf("switchDocumentsListRemoveNode\n");    
+    if(nodeToRemove->next != NULL)
+    {
+	if(nodeToRemove->previous == NULL)
+	{//nodeToRemove is first node in list
+
+    	    nodeToRemove->next->previous = NULL;
+	    firstNodeInSwitchDocumentsList = nodeToRemove->next;
+
+	}
+	else
+	{//nodeToRemove is not first node in list
+	    nodeToRemove->previous->next = nodeToRemove->next;
+	    nodeToRemove->next->previous = nodeToRemove->previous;
+	}
+	free(nodeToRemove);
+    }
+    else
+    {
+	printf("switchDocumentsListRemoveNode() error: removing dummy node is impossible: (nodeToRemove->next == NULL)\n");
+	exit(0);
+    }   
+
+    SwitchDocumentsList* lastNodeInList = switchDocumentsGetLastNodeInList();
+
+    //printWindowList();	//debug
+    //printf("finish switchDocumentsListRemoveNode\n");   
+        
+    return lastNodeInList;     //update activeNodeInSwitchDocumentsList (restore to last document in list) 
+}
+
+SwitchDocumentsList* switchDocumentsListRemove(WindowInfo * focusDocument)
+{
+    SwitchDocumentsList* currentNode = firstNodeInSwitchDocumentsList;
+    SwitchDocumentsList* nodeToRemove = NULL;
+    int foundNodeToRemove = 0;
+    while(currentNode->next != NULL)
+    {
+    	//printf("currentNode = %d\n", currentNode->windowIDdebug);    
+    	if(currentNode->focusDocument == focusDocument)
+	{
+	    //printf("found node to remove");
+	    nodeToRemove = currentNode;
+	    foundNodeToRemove = 1;
+	}
+    	currentNode = currentNode->next;
+    }
+    SwitchDocumentsList* lastNodeInList = currentNode;
+    if(foundNodeToRemove)
+    {
+    	 lastNodeInList = switchDocumentsListRemoveNode(nodeToRemove);
+    }
+    else
+    {	
+    	 //printf("error: !foundNodeToRemove\n");
+    }
+    return lastNodeInList;
+}
+
+
+SwitchDocumentsList* switchDocumentsListAdd(WindowInfo * focusDocument)
+{
+    //printf("switchDocumentsListAdd\n");
+    //printf("removing document %d\n", focusDocument);
+    switchDocumentsListRemove(focusDocument);	//remove previous instance if existent
+      
+    SwitchDocumentsList* currentNode = firstNodeInSwitchDocumentsList;
+    int lastNewWindowIDdebug = 0;
+    while(currentNode->next != NULL)
+    {
+	lastNewWindowIDdebug = currentNode->windowIDdebug;
+    	currentNode = currentNode->next;
+    }
+    currentNode->windowIDdebug = lastNewWindowIDdebug+1;
+    //printf("adding node = %d\n", currentNode->windowIDdebug);    
+    currentNode->focusDocument = focusDocument;
+    SwitchDocumentsList* newNode = malloc(sizeof(SwitchDocumentsList));
+    newNode->focusDocument = NULL;
+    newNode->next = NULL;
+    newNode->previous = currentNode;
+    currentNode->next = newNode;
+    //printWindowList();	//debug
+    //printf("finish switchDocumentsListAdd\n");  
+      
+    return currentNode;
+}
+
+#endif
+
 static int DoneWithMoveDocumentDialog;
 static int updateLineNumDisp(WindowInfo* window);
 static int updateGutterWidth(WindowInfo* window);
@@ -800,6 +970,14 @@
 	}
     }
     
+    #ifdef SWITCH_DOCUMENTS_PATCH
+    //printf("CreateWindow\n");    
+    //printf("window = %d\n", window);  
+    activeNodeInSwitchDocumentsList = switchDocumentsListAdd(window);
+    //printWindowList();	//debug
+    //printf("CreateWindow\n");      
+    #endif
+        
     return window;
 }
 
@@ -3785,7 +3963,7 @@
     
     if (window)
     	lastFocusDocument = window;
-	
+    	
     return prev;
 }
 
@@ -3799,6 +3977,21 @@
     if (window)
     	inFocusDocument = window;
 
+    #ifdef SWITCH_DOCUMENTS_PATCH
+    //printf("MarkActiveDocument\n");    
+    //printf("inFocusDocument = %d\n", inFocusDocument);  
+    if(switchDocumentsListTraverseDisableMarkActiveDocument == 0)
+    {
+	if(switchingDocumentsAtPresent == 1)
+	{//in strange case user is switching documents while creating a new window for example?
+    	    activeNodeInSwitchDocumentsList = switchDocumentsListAdd(activeNodeInSwitchDocumentsList->focusDocument);	
+	    switchingDocumentsAtPresent = 0; 
+	} 
+    	activeNodeInSwitchDocumentsList = switchDocumentsListAdd(inFocusDocument);
+    }  
+    //printf("finish MarkLastDocument\n");      
+    #endif
+
     return prev;
 }
 
@@ -3863,6 +4056,73 @@
 	
 }
 
+#ifdef SWITCH_DOCUMENTS_PATCH
+
+void switchDocumentsEnd(WindowInfo *window)
+{
+	//printf("switchDocumentsEnd\n");  
+	if(switchingDocumentsAtPresent == 1)
+	{
+    		activeNodeInSwitchDocumentsList = switchDocumentsListAdd(activeNodeInSwitchDocumentsList->focusDocument);
+		switchingDocumentsAtPresent = 0;
+	}
+}
+/*
+** Switch through last active windows
+*/
+void switchDocuments(WindowInfo *window, int direction)
+{
+    //printf("switchDocuments\n");  
+    WindowInfo *win;
+
+    if((activeNodeInSwitchDocumentsList->previous != NULL) || (activeNodeInSwitchDocumentsList->next->next != NULL))
+    {
+	if(direction == SWITCH_DOCUMENTS_PATCH_DIRECTION_NORMAL)
+	{
+	    if(activeNodeInSwitchDocumentsList->previous != NULL)
+	    {
+		activeNodeInSwitchDocumentsList = activeNodeInSwitchDocumentsList->previous;
+	    }
+	    else
+	    {//go around in circles...
+		activeNodeInSwitchDocumentsList = switchDocumentsGetLastNodeInList();
+	    }
+	}
+	else if(direction != SWITCH_DOCUMENTS_PATCH_DIRECTION_NORMAL)
+	{
+	    if(activeNodeInSwitchDocumentsList->next->next != NULL)
+	    {
+		activeNodeInSwitchDocumentsList = activeNodeInSwitchDocumentsList->next;
+	    }
+	    else
+	    {//go around in circles...
+		activeNodeInSwitchDocumentsList = firstNodeInSwitchDocumentsList;
+	    }	
+	}
+    }
+    //printf("activeNodeInSwitchDocumentsList = ", activeNodeInSwitchDocumentsList);
+    switchingDocumentsAtPresent = 1;
+        
+    for(win = WindowList; win; win=win->next)
+    	if (activeNodeInSwitchDocumentsList->focusDocument == win)
+	    break;
+    
+    if (!win)
+    	return;
+
+    switchDocumentsListTraverseDisableMarkActiveDocument = 1;
+
+    if (window->shell == win->shell)
+	RaiseDocument(win);
+    else
+    	RaiseDocumentWindow(win);
+
+    switchDocumentsListTraverseDisableMarkActiveDocument = 0;	
+    //printf("finish switchDocuments\n");  
+}
+#endif
+
+ 
 /*
 ** make sure window is alive is kicking
 */
@@ -4059,6 +4319,10 @@
         return;
     }
 
+    #ifdef SWITCH_DOCUMENTS_PATCH
+    switchDocumentsListRemove(window);   
+    #endif
+
     XtDestroyWidget(window->splitPane);
 }
 
diff -urNad nedit-5.6~cvs20081118~/source/window.h nedit-5.6~cvs20081118/source/window.h
--- nedit-5.6~cvs20081118~/source/window.h	2014-02-02 14:59:37.980168305 +1100
+++ nedit-5.6~cvs20081118/source/window.h	2014-02-02 14:59:42.844168269 +1100
@@ -84,6 +84,12 @@
 void NextDocument(WindowInfo *window);
 void PreviousDocument(WindowInfo *window);
 void LastDocument(WindowInfo *window);
+#ifdef SWITCH_DOCUMENTS_PATCH
+#define SWITCH_DOCUMENTS_PATCH_DIRECTION_NORMAL (1)
+#define SWITCH_DOCUMENTS_PATCH_DIRECTION_REVERSE (2)
+void switchDocuments(WindowInfo *window, int direction);
+void switchDocumentsEnd(WindowInfo *window);
+#endif
 int NDocuments(WindowInfo *window);
 WindowInfo *MoveDocument(WindowInfo *toWindow, WindowInfo *window);
 WindowInfo *DetachDocument(WindowInfo *window);
